=head1 NAME

perlcommunity - a brief overview of the Perl community

=head1 DESCRIPTION

This document aims to provide an overview of the vast perl community, which is
far too large and diverse to provide a detailed listing. If any specific niche
has been forgotten, it is not meant as an insult but an omission for the sake
of brevity.

The Perl community is as diverse as Perl, and there is a large amount of
evidence that the Perl users apply TMTOWTDI to all endeavors, not just
programming. From websites, to IRC, to mailing lists, there is more than one
way to get involved in the community.

=head2 Where to Find the Community

There is a central directory for the Perl community: L<https://perl.org>
maintained by the Perl Foundation (L<https://www.perlfoundation.org/>),
which tracks and provides services for a variety of other community sites.

=head3 Raku

Perl's sister language, Raku (formerly known as Perl 6), maintains its own
directory of community resources at L<https://raku.org/community/>.

=head2 Mailing Lists and Newsgroups

Perl runs on e-mail; there is no doubt about it. The Camel book was originally
written mostly over e-mail and today Perl's development is co-ordinated through
mailing lists. The largest repository of Perl mailing lists is located at
L<https://lists.perl.org>.

Most Perl-related projects set up mailing lists for both users and
contributors. If you don't see a certain project listed at
L<https://lists.perl.org>, check the particular website for that project.
Most mailing lists are archived at L<https://www.nntp.perl.org/>.

=head2 IRC

The Perl community has a rather large IRC presence. For starters, it has its
own IRC network, L<irc://irc.perl.org>. General (not help-oriented) chat can be
found at L<irc://irc.perl.org/#perl>. Many other more specific chats are also
hosted on the network. Information about irc.perl.org is located on the
network's website: L<https://www.irc.perl.org>. For a more help-oriented #perl,
check out L<irc://irc.libera.chat/#perl>
(L<webchat|https://web.libera.chat/#perl>). Most Perl-related channels
will be kind enough to point you in the right direction if you ask nicely.

Any large IRC network (Dalnet, EFnet) is also likely to have a #perl channel,
with varying activity levels.

=head2 Websites

Perl websites come in a variety of forms, but they fit into two large
categories: forums and news websites. There are many Perl-related
websites, so only a few of the community's largest are mentioned here.

=head3 News sites

=over 4

=item L<https://perl.com/>

Originally run by O'Reilly Media (the publisher of L<the Camel Book|perlbook>,
this site provides quality articles mostly about technical details of Perl.

=item L<http://blogs.perl.org/>

Many members of the community have a Perl-related blog on this site. If
you'd like to join them, you can sign up for free.

=item L<https://perl.theplanetarium.org/>

Planet Perl is one of several aggregators of Perl-related blog feeds.

=item L<https://perlweekly.com/>

Perl Weekly is a weekly mailing list that keeps you up to date on conferences,
releases and notable blog posts.

=back

=head3 Forums

=over 4

=item L<https://www.perlmonks.org/>

PerlMonks is one of the largest Perl forums, and describes itself as "A place
for individuals to polish, improve, and showcase their Perl skills." and "A
community which allows everyone to grow and learn from each other."

=item L<https://stackoverflow.com/>

Stack Overflow is a free question-and-answer site for programmers. It's not
focussed solely on Perl, but it does have an active group of users who do
their best to help people with their Perl programming questions.

=item L<http://prepan.org/>

PrePAN is used as a place to discuss modules that you're considering uploading
to the CPAN.  You can get feedback on their design before you upload.

=back

=head2 User Groups

Many cities around the world have local Perl Mongers chapters. A Perl Mongers
chapter is a local user group which typically holds regular in-person meetings,
both social and technical; helps organize local conferences, workshops, and
hackathons; and provides a mailing list or other continual contact method for
its members to keep in touch.

To find your local Perl Mongers (or PM as they're commonly abbreviated) group
check the international Perl Mongers directory at L<https://www.pm.org/>.

=head2 Workshops

Perl workshops are, as the name might suggest, workshops where Perl is taught
in a variety of ways. At the workshops, subjects range from a beginner's
introduction (such as the Pittsburgh Perl Workshop's "Zero To Perl") to much
more advanced subjects.

There are several great resources for locating workshops: the
L<websites|"Websites"> mentioned above, the
L<calendar|"Calendar of Perl Events"> mentioned below, and the YAPC Europe
website, L<http://www.yapceurope.org/>, which is probably the best resource for
European Perl events.

=head2 Hackathons

Hackathons are a very different kind of gathering where Perl hackers gather to
do just that, hack nonstop for an extended (several day) period on a specific
project or projects. Information about hackathons can be located in the same
place as information about L<workshops|"Workshops"> as well as in
L<irc://irc.perl.org/#perl>.

If you have never been to a hackathon, here are a few basic things you need to
know before attending: have a working laptop and know how to use it; check out
the involved projects beforehand; have the necessary version control client;
and bring backup equipment (an extra LAN cable, additional power strips, etc.)
because someone will forget.

=head2 Conventions

Perl had two major annual conventions: The Perl Conference (now part of OSCON),
put on by O'Reilly, and Yet Another Perl Conference or YAPC (pronounced
yap-see), which is localized into several regional YAPCs (North America,
Europe, Asia) in a stunning grassroots display by the Perl community.

In 2016, YAPC was rebranded as The Perl Conference again. It is now referred
to as The Perl and Raku Conference.

OSCON had been discontinued.

For more information about either conference, check out their respective web
pages:

=over 4

=item * The Perl Conference

L<http://perlconference.us/>.

=item * OSCON

L<https://www.oreilly.com/conferences/>

=back

An additional conference franchise with a large Perl portion was the
Open Source Developers Conference or OSDC. First held in Australia, it
also spread to Israel and France. More information can be found at:
L<http://www.osdc.org.il> for Israel, and L<http://www.osdc.fr/> for France.

=head2 Calendar of Perl Events

The Perl Review, L<http://www.theperlreview.com> maintains a website
and Google calendar for tracking
workshops, hackathons, Perl Mongers meetings, and other events. A view
of this calendar is available at L<https://www.perl.org/events.html>.

Not every event or Perl Mongers group is on that calendar, so don't lose
heart if you don't see yours posted. To have your event or group listed,
contact brian d foy (brian@theperlreview.com).

=head1 AUTHOR

Edgar "Trizor" Bering <trizor@gmail.com>

=cut
